Name: slang
Version: 2.3.1a
Release: 3
License: GPL-3.0-or-later
Summary: S-Lang Programmer's Library
Url: https://www.jedsoft.org/slang

Source0: https://www.jedsoft.org/releases/slang/old/slang-%{version}.tar.bz2

BuildRequires: pase-build-tools
BuildRequires: zlib-devel

Patch0: slang-fix-libslang-rebuild.patch

%description
S-Lang is a multi-platform programmer's library designed to allow a developer
to create robust multi-platform software. It provides facilities required by
interactive applications such as display/screen management, keyboard input,
keymaps, and so on. The most exciting feature of the library is the slang
interpreter that may be easily embedded into a program to make it extensible.
While the emphasis has always been on the embedded nature of the interpreter,
it may also be used in a stand-alone fashion through the use of slsh, which
is part of the S-Lang distribution.

%package -n libslang2
Summary: S-Lang library
Obsoletes: slang

%description -n libslang2
S-Lang library

%package -n slsh
Summary: S-Lang shell

%description -n slsh
S-Lang shell

%package devel
Summary: S-Lang development files
Requires: libslang2 = %{version}

%description devel
S-Lang development files

%prep
%setup -q

%patch0 -p1

%build

# The Makefiles have a horrible dependency setup, so nothing gets serialized
# properly when running with multiple jobs, so we limit it to 1
%define _smp_ncpus_max 1

%configure \
  LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib" \
  --build=powerpc64-ibm-aix6 \
#end

BASE=$PWD

cd $BASE/src
%make_build

# slang doesn't support building the shared library the way we want
# so we manually do that here.
cd elfobjs

svr4-shrlib libslang.so.2.3.1 libslang.so.2 %{_arch}


cd $BASE/modules
# the modules are plugins loaded by the interpreter and use functions provided
# by it. In the default slang build, it does not link these modules to libslang
# since those symbols can be provided at runtime, but the AIX linker will throw
# an error if it can't resolve symbols. We'll modify the previously built import
# file for libslang.so to tell it to be resolved at run-time.
#
# NOTE: We could just as easily use -berok, but that would allow it to continue
# to link in the face of non-slang symbols not being found, which would be an
# error.

# extract the slang symbol list and change the import path to ..
ar x $BASE/src/elfobjs/libslang.so.2 shr_64.imp
perl -p -i -e 's|#!.*|#! ..|g' shr_64.imp 

%make_build SLANG_LIB=$PWD/shr_64.imp

cd $BASE/slsh
%make_build

%install

%make_install

rm %{buildroot}%{_libdir}/libslang.so.2
mv %{buildroot}%{_libdir}/libslang.so.2.3.1 %{buildroot}%{_libdir}/libslang.so.2


%files -n libslang2
%defattr(-, qsys, *none)

%{_libdir}/libslang.so.2
%{_libdir}/slang/v2/modules

%files -n slsh
%defattr(-, qsys, *none)
%{_bindir}/slsh
%{_sysconfdir}/slsh.rc
%{_datarootdir}/slsh/*

%files devel
%defattr(-, qsys, *none)

%{_libdir}/libslang.so
%{_libdir}/pkgconfig/slang.pc
%{_includedir}/slang.h
%{_includedir}/slcurses.h
%{_docdir}/slang/v2/*
%{_docdir}/slsh/html/*
%{_mandir}/man1/slsh.1	


%changelog
* Tue Dec 17 2019 Mark Irish <mirish@ibm.com> - 2.3.1a
- Use SPDX license identifier

* Tue Mar 26 2019 Kevin Adler <kadler@us.ibm.com> - 2.3.1a
- ibm-build-tools -> pase-build-tools

* Sat Aug 04 2018 - Kevin Adler <kadler@us.ibm.com>
- Use -blibpath, so programs load correctly
- Build svr4-style libraries
- Instead of using -berok, tell the modules to use the libslang import file to find symbols

* Thu May 31 2018 - Eric Simpson <esimpson@ca.ibm.com>
- Create slang.spec
